#!/usr/bin/python
import sys

ring="Int"
n=int(sys.argv[1])
deltaY=2
deltaZ=3
add_fast_clauses=False
use_ite=False

if ring == "Int":
#  print "(set-logic QF_LIA)"
  print "(set-logic QF_IDL)"
elif ring == "Real":
#  print "(set-logic QF_LRA)"
  print "(set-logic QF_RDL)"

for i in xrange(n):
  print "(declare-fun x{0} () {1})".format(i, ring)
  print "(declare-fun y{0} () {1})".format(i, ring)
  print "(declare-fun z{0} () {1})".format(i, ring)
  print "(declare-fun b{0} () Bool)".format(i)
print "(declare-fun x{0} () {1})".format(n, ring)

print

for i in xrange(n):
  print "(assert (<= y{0} (+ x{0} {1})))".format(i, deltaY)
  print "(assert (<= z{0} (+ x{0} {1})))".format(i, deltaZ)
  if use_ite:
    print "(assert (= x{1} (ite b{0} y{0} z{0})))".format(i, i+1)
  else:
    print "(assert (or (<= x{1} y{0}) (<= x{1} z{0})))".format(i, i+1)
  if add_fast_clauses:
    print "(assert (<= x{0} (+ x{1} {2})))".format(i+1, i, max(deltaY, deltaZ))
  
print
print "(assert (> x{0} {1}))".format(n, max(deltaY, deltaZ)*n)
print "(assert (= x0 0))"
print "(check-sat)"

