#!/usr/bin/python
import sys

ring="Real"
n=int(sys.argv[1])
deltaY=2
deltaZ=3
add_fast_clauses=False
use_ite=True

print "(set-logic HORN)"

for i in xrange(n):
  print "(declare-fun blockA{0} (Bool {1} {1}) Bool)".format(i, ring)
  print "(declare-fun blockB{0} (Bool {1} {1}) Bool)".format(i, ring)

print

for i in xrange(n):
   print "(assert (forall ((clock {1})) (blockA{0} true clock (+ clock {2}))))".format(i, ring, deltaY)
   print "(assert (forall ((clock {1})) (blockA{0} false clock (+ clock {2}))))".format(i, ring, deltaZ)
   print "(assert (forall ((clock {1})) (blockB{0} true clock (+ clock {2}))))".format(i, ring, deltaZ)
   print "(assert (forall ((clock {1})) (blockB{0} false clock (+ clock {2}))))".format(i, ring, deltaY)

print "(declare-fun prog ({0} {0}) Bool)".format(ring)
print "(assert (forall (",
for i in xrange(n+1):
   print "(clock{0} {1}) (clockB{0} {1}) (b{0} Bool)".format(i, ring),
print ") (=> (and",
for i in xrange(n):
   print "(blockA{0} b{0} clock{0} clockB{0}) (blockB{0} b{0} clockB{0} clock{1}) ".format(i, i+1),
print ") (prog clock{0} clock{1}))))".format(0, n)

print "(assert (forall ((final_time {0})) (=> (prog 0 final_time) (<= final_time {1}))))".format(ring, (deltaY + deltaZ)*n)
print "(check-sat)"
#print "(get-model)"
